django/myfirst/articles/urls.py
from django.urls import path
from . import views
app_name='articles'

urlpatterns=[
    path('',views.index,name="index"),
	# path("tree/",views.tree, name="tree")
    path('<int:article_id>/',views.detail,name="detail"),

    path('<int:article_id>/leave_comment/',views.leave_comment,name="leave_comment"),

]

django/myfirst/myfirst/urls.py
from django.contrib import admin
from django.urls import path,include

urlpatterns = [
    # path('admin/', admin.site.urls),
    path('articles/',include('articles.urls')),
    path('grappelli/', include('grappelli.urls')), # grappelli URLS
    path('admin/', admin.site.urls), # admin site
]

django/myfirst/articles/models.py
from django.db import models
from django.utils import timezone
import datetime

# Create your models here.

class Article(models.Model):
    article_title = models.CharField('Article Cat', max_length=20)
    article_text = models.TextField('cat is an animal')
    pub_date = models.DateTimeField('date of publishing')

    def __str__(self):
        return self.article_title

    def date_recently(self):
        return self.pub_date>=(timezone.now()-datetime.timedelta(days=3))


class Comment(models.Model):
    article = models.ForeignKey(Article, on_delete=models.CASCADE)
    author_name = models.CharField('Author`s name', max_length=50)
    comment_text = models.CharField('cat is an animal', max_length=500)

    def __str__(self):
        return self.author_name

django/myfirst/articles/views.py
# from django.http import HttpResponse
# def index(request):
#     return HttpResponse("hello!")
# def tree(request):
# 	return HttpResponse("Happy my!")
#
# # Create your views here.

from django.http import Http404, HttpResponseRedirect
from django.shortcuts import render
from .models import Article
from django.urls import reverse

def index(request):
    latest_articles_list = Article.objects.order_by('-pub_date')[:5]
    return render(request, 'articles/list.html', {'latest_articles_list': latest_articles_list})


def detail(request, article_id):
    try:
        a = Article.objects.get(id=article_id)
    except:
        raise Http404("article is not found")
    latest_comment_list=a.comment_set.order_by('-id')[:10]
    return render(request,'articles/detail.html',{'article':a,'latest_comment_list':latest_comment_list})

def leave_comment(request,article_id):
    try:
        a = Article.objects.get(id=article_id)
    except:
        raise Http404("article is not found")
    a.comment_set.create(author_name=request.POST['name'],comment_text=request.POST['text'])
    return HttpResponseRedirect(reverse('articles:detail',args=(a.id,)))

django/myfirst/templates/articles/detail.html
{%extends 'base.html' %}


{%block title %}{{article.article_title}}{%endblock%}

{%block content %}
<h2>{{article.article_title}}</h2>
<p>{{article.article_text}}</p>
<em>{{article.pub_date}}</em>

    {%if article.date_recently%}
        NEW_article!
    {%endif%}

<hr>
    {%if latest_comment_list%}
        {%for c in latest_comment_list%}
            <p>
                <strong>
                    {{c.author_name}}
                </strong>
                <p>
                    {{c.comment_text}}
                </p>

            </p>

        {%endfor%}
    {%else%}
    No comments yet...
    {%endif%}

<hr>
<form action="{%url 'articles:leave_comment' article.id %}" method="POST">
    {% csrf_token %}
    <input type="text" required placeholder="name" name="name"><br>
    <textarea name="text" required="" placeholder="text" cols="30" rows="10">
    </textarea><br>
    <button type="submit">Send comment</button>
</form>
{%endblock%}

django/myfirst/templates/articles/list.html
{%extends 'base.html' %}


{%block title %}Recent articles{%endblock%}

{%block content %}
    {%if latest_articles_list %}
        {%for a in latest_articles_list %}
            <a href="{% url 'articles:detail' a.id %}">{{a.article_title}} </a>
        {%endfor%}
    {%else%}
        Dogs site..
    {%endif%}

{%endblock%}

django/myfirst/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>{% block title %}My site{% endblock %}</title>
</head>
<body>
    {% block content %}{% endblock %}
</body>
</html>